# -*- coding:utf-8 -*-
"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.

"""

__pmshell_script__ = 'PyMyShell'
__pmshell_ver__ = '0.02(3)'
__pmshell_author__ = 'masa'
__pmshell_web__ = 'http://masaland.cocolog-nifty.com/'
#__copyright__ = 'Copyright (C) 2008,2009 masa'
__pmshell_copyr__     = '(C) 2008,2009 masa'

import sys
sys.setdefaultencoding('utf-8')
sys.path.insert(0, 'E:\\Python\\lib')

import os
import appuifw
import e32
import re
import dir_iter
import time
from key_codes import EKeyLeftArrow
from key_codes import EKeyRightArrow

appuifw2_exist = 0
try:
    import appuifw2
    #appuifw = appuifw2
    appuifw2_exist = 1
except ImportError:
    #pass
    appuifw2_exist = 0

#------- config data---------------------------
__pmshell_inifile__ = 'E:/Data/masa/PyMyShell.ini'
pmshell_Jump_range = 4 #Jump range (Right/Left Arrow key)

pmshell_Lists ={
    unicode('ふぶき')        :u'E:/Python/fubuki_m.py',
    unicode('ふぶき変換')    :u'E:/Python/fubuki2htm.py',
    unicode('画像リサイズ')  :u'E:/Python/PyResizeJpgS.py',
    unicode('ファイル転送')  :u'E:/Python/PyMyFTP.py',
    unicode('電話帳')        :u'E:/Python/jContacts.py',
    unicode('ノートNdb')     :u'E:/Python/PyNoteNdb.py',
    unicode('ノートPad')     :u'E:/Python/PyNotePad.py',
    unicode('st2ch')         :u'E:/Python/st2ch.py',
    unicode('Filebrowser')   :u'E:/Python/Filebrowser.py' ,
    unicode('PyMyEditor')    :u'E:/Python/PyMyEditor.py'
        }
#EXT_FLG = 0
#----------------------------------------------

def confread():
    global pmshell_Lists
    global pmshell_Jump_range

    try:
        F = open(__pmshell_inifile__,'r')
        FData = F.read()
        F.close()
    except:
        return

    FLists  = {}
    FLists2 = {}
    cnt = cnt2 = 0
    #split by \n and omit line that contain only (CR/LF)
    lnDatalist = [x for x in FData.split("\n") if len(x) > 1]

    for lnData in lnDatalist:
        lnDatawk = re.sub("[ \t]+"," ",lnData)
        lnDatawk = (re.sub("[\n\r]+","",lnDatawk)).strip()
        confData = lnDatawk.split(" ")
        if len(confData) < 2: continue # no confData[1] error
        if   confData[0] == "Jump_range" : pmshell_Jump_range = int(confData[1])
        elif confData[0] == "Lists":
            if len(confData) > 2: # 
                #Insert "no_" 
                cnt = cnt + 1
                if cnt < 10 : cnt_str = '0'+str(cnt)+'_'
                else:         cnt_str = str(cnt)+'_'
                FLists.update({unicode(cnt_str + confData[1]):unicode(confData[2])})
    if   FLists : pmshell_Lists = FLists


class Shell:
    def __init__(self):
        self.lock = e32.Ao_lock()
        self.lists = pmshell_Lists
        self.sel_list = []

    def run(self):
        confread()
        self.lists = pmshell_Lists
        self.sel_list = self.lists.keys()
        self.sel_list.sort()
        if appuifw2_exist == 1:
            self.sel_listbox = appuifw2.Listbox(self.sel_list,self.exec_app)
        else:
            self.sel_listbox = appuifw.Listbox(self.sel_list,self.exec_app)
        self.sel_listbox.bind(EKeyLeftArrow, lambda: self.jump('b'))
        self.sel_listbox.bind(EKeyRightArrow, lambda: self.jump('f'))
        old_title = appuifw.app.title
        self.refresh()
        self.lock.wait()
        appuifw.app.title = old_title
        appuifw.app.body = None
        self.sel_listbox = None

    def refresh(self):
        appuifw.app.title = unicode(__pmshell_script__)
        appuifw.app.menu = [(u'Exec app',self.exec_app ),
                            (u'About',self.about ),
                            (u'Exit', self.exit_key_handler)]
        appuifw.app.exit_key_handler = self.do_dummy #self.exit_key_handler
        appuifw.app.body = self.sel_listbox


    def do_dummy(self):
        return

    def do_exit(self):
        self.lock.signal()

    def exit_key_handler(self):
        global EXT_FLG
        appuifw.app.exit_key_handler = None
        EXT_FLG = 1
        self.lock.signal()

    def exec_app(self):
        i = self.sel_listbox.current()
        item = self.lists.get(self.sel_list[i])
        execfile(item, globals())
        self.refresh()
        #delete duplicated E/C:\Python\lib
        flg_Elib = flg_Clib = 0
        wk = []
        for n in range(0, len(sys.path)):
            if (sys.path[n]).upper() == 'E:\\PYTHON\\LIB':
                if flg_Elib == 0:
                    wk.append(sys.path[n])
                    flg_Elib = 1
            elif (sys.path[n]).upper() == 'C:\\PYTHON\\LIB':
                if flg_Clib == 0:
                    wk.append(sys.path[n])
                    flg_Clib = 1
            else:
                wk.append(sys.path[n])
        sys.path = wk


    def about(self):
        msg = ('App : ' + __pmshell_script__ + '\n') + \
              ('Ver : ' + __pmshell_ver__ + '\n') + \
              (__pmshell_copyr__ + '\n') + \
              (__pmshell_web__ )
        appuifw.query(unicode(msg, "utf-8"), "query")

    def jump(self, flg):
        i = self.sel_listbox.current()
        i_max = len(self.sel_list) - 1
        if flg == 'f': # jump forward
            i = i + pmshell_Jump_range
            if i > i_max : i = i_max
        else: # b jump backward
            i = i - pmshell_Jump_range
            if i < 0 : i = 0
        self.sel_listbox.set_list(self.sel_list, i)


def main():
    S = Shell()
    S.run()
    del S

if __name__ == '__main__':
    main()
appuifw.app.set_exit()
#sys.exit()
